
####### Evaluate the effcet of GPS sampling frequency on results, for comparison with WA
##### Resample Rebel data at every 14min (every 7 fixes),
##### calculate bird boat correspondance with boats interpolated to the 10 min,
##### Establish series, metaseries data
##### and perform parallel analyses to that for 2min frequency.

setwd("D:/Pro/These/Donnees/BBA/BBA2011ToVessels/")

vesselsdata="D:/Pro/These/Donnees/Bateaux/VesselsData/InterpolCombinedReady/Ker2011/"
boatfiles=list.files(vesselsdata)


bi=read.table("AllBirds14minAllBoats10min.csv",sep=";",h=T)

library(geosphere)
##### Attrac and attend locs
attrac.threshold=30   # we define attraction area as a 30km circle aound boats
sitting.threshold=10/3.6   # we consider locations with speed<10km/h to be sitting on water
attend.threshold=3   # birds sitting within 3km of vessels will be considered attending boats
timetoreturn=4


### We assign an index for all boats of the study, so to retrieve coresponding columns
nbvessels=7
disttoves=c()
for (i in 1:nbvessels){
  disttoves=c(disttoves,paste("DistToVes10_",i,sep=""))
}



#extract and combine bird date and time
birdtime=as.POSIXct(apply(cbind(as.character(bi$Date),as.character(bi$Time)),1,function(X){
  Date=unlist(strsplit(as.character(X[1]),"/"))
  Time=as.character(X[2])
  out=paste(paste(as.character(Date[3]),as.character(Date[2]),as.character(Date[1]), sep='-'),Time, sep=' ')
  return(out)
}),tz='GMT')

#bi$Loc=seq(1,dim(bi)[1])

bi$Speed_ms=c(distCosine(cbind(bi$Longitude,bi$Latitude)[-dim(bi)[1],],cbind(bi$Longitude,bi$Latitude)[-1,])/as.double(-difftime(birdtime[-dim(bi)[1]],birdtime[-1],units="secs")),NA)
bi$Heading=as.double(c(bearing(cbind(bi$Longitude,bi$Latitude)[-dim(bi)[1],],cbind(bi$Longitude,bi$Latitude)[-1,]),NA))%%360

coldist=which(names(bi)%in%disttoves)
bi$ClosestVes=apply(bi,1,function(X){ifelse(sum(is.na(X[coldist]))<nbvessels,which.min(as.double(X[coldist])),NA)})
bi$MinDistVes=as.double(apply(bi,1,function(X){ifelse(sum(is.na(X[coldist]))<nbvessels,min(as.double(X[coldist]),na.rm=T),NA)}))

bi$SitOnWater=ifelse(bi$Speed_ms<=sitting.threshold,"sit","fly")
bi$AttendBoat=ifelse(bi$SitOnWater=="sit" & bi$MinDistVes<attend.threshold,1,0)

sunelev=tripEstimation::elevation(bi$Longitude,bi$Latitude,tripEstimation::solar(birdtime))
bi$DayNight=ifelse(sunelev>(-6),"day","night")



allattrloc=bi[bi$MinDistVes<attrac.threshold,]

birdtime=as.POSIXct(apply(cbind(as.character(allattrloc$Date),as.character(allattrloc$Time)),1,function(X){
  Date=unlist(strsplit(as.character(X[1]),"/"))
  Time=as.character(X[2])
  out=paste(paste(as.character(Date[3]),as.character(Date[2]),as.character(Date[1]), sep='-'),Time, sep=' ')
  return(out)
}),tz='GMT')

allattrloc$LocBird=allattrloc$Loc/7

serie=1
prevser=1
indtr=as.character(allattrloc$TripID[1])
prevloc=allattrloc$LocBird[1]
for (l in 2:length(allattrloc$Latitude)){
  serie=c(serie,ifelse(allattrloc$TripID[l]!=indtr,1,ifelse(((allattrloc$LocBird[l]-prevloc)<timetoreturn),prevser,prevser+1)))
  prevser=serie[l]
  indtr=as.character(allattrloc$TripID[l])
  prevloc=allattrloc$LocBird[l]
}

allattrloc$Serie=serie

allattrloc$NbBatRangeDet=apply(allattrloc,1,function(X){ifelse(sum(is.na(X[c(59,65,71,77,83,89,95)]))<7,sum(as.double(as.character(X[c(59,65,71,77,83,89,95)]))<30,na.rm=T),0)})
#write.table(allattrloc,file=paste("BBA14minBoat10min_","AllAttrLoc_",attrac.threshold,"km_",attend.threshold,"km_","TTR",timetoreturn,"locs.csv",sep=""),sep=";",row.names=F)



attrser=c()
allindtr=unique(allattrloc$TripID)
k=0
for (it in allindtr){ # for each track
  nbser=max(allattrloc$Serie[allattrloc$TripID==it],na.rm=T)
  for (ser in 1:nbser){ # for each encounter in the track
    bird=unlist(strsplit(as.character(it),","))[1]
    ### Length of encounter event
    durser=sum(allattrloc$TripID==it & allattrloc$Serie==ser,na.rm=T)
    
    durserday=sum(allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$DayNight=="day",na.rm=T)
    
    ### Parameters to establish correspondence to bird file
    startloc=allattrloc$LocBird[allattrloc$TripID==it & allattrloc$Serie==ser][1]
    endloc=allattrloc$LocBird[allattrloc$TripID==it & allattrloc$Serie==ser][durser]
    startdate=as.character(allattrloc$Date[allattrloc$TripID==it & allattrloc$Serie==ser][1])
    starttime=as.character(allattrloc$Time[allattrloc$TripID==it & allattrloc$Serie==ser][1])
    enddate=as.character(allattrloc$Date[allattrloc$TripID==it & allattrloc$Serie==ser][durser])
    endtime=as.character(allattrloc$Time[allattrloc$TripID==it & allattrloc$Serie==ser][durser])
    
    ### Parameters to establish correspondence to vessel file
    vessel=as.character(allattrloc$ClosestVes[allattrloc$TripID==it & allattrloc$Serie==ser][1])
    namecollocbat=which(names(allattrloc)==paste("LocBat10_",vessel,sep=""))
    startlocbat=as.character(allattrloc[allattrloc$TripID==it & allattrloc$Serie==ser,namecollocbat][1])
    endlocbat=as.character(allattrloc[allattrloc$TripID==it & allattrloc$Serie==ser,namecollocbat][durser])
    
    ### Parameters to exclude night encounters, or encounters without flying locations
    day_prop=sum(allattrloc$DayNight[allattrloc$TripID==it & allattrloc$Serie==ser]=="day",na.rm=T)/durser
    dayflight=ifelse(length(allattrloc$DayNight[allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$DayNight=="day" & allattrloc$SitOnWater=="fly"])>0,1,0)
    startatday=as.character(allattrloc$DayNight[allattrloc$TripID==it & allattrloc$Serie==ser][1])
    
    ### How many boats are within detection range during the encounter
    avg_nbbatrangedet=mean(allattrloc$NbBatRangeDet[allattrloc$TripID==it & allattrloc$Serie==ser],na.rm=T)
    
    ### Attendance parameters
    #How long did it attend
    dur_attend=sum(allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$AttendBoat==1)
    dur_attend_day=sum(allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$AttendBoat==1 & allattrloc$DayNight=="day")
    
    #did it attend
    attend=ifelse(dur_attend>0,1,0)
    #what proportion of the encounter event it spent attending
    prop_attend=dur_attend/durser
    dayprop_attend=dur_attend_day/durserday
    #at what average distance from boats when attending
    avgdist_attend=mean(allattrloc$MinDistVes[allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$AttendBoat==1],na.rm=T)
    avgdist_dayattend=mean(allattrloc$MinDistVes[allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$AttendBoat==1 & allattrloc$DayNight=="day"],na.rm=T)
    
    #stderrdistattend=stderr(allattrloc$MinDistVes[allattrloc$TripID==it & allattrloc$Serie==ser & allattrloc$AttendBoat==1])
    
    attrser=rbind(attrser,c(bird,it,ser,startloc,startlocbat,startdate,starttime,endloc,endlocbat,enddate,endtime,durser,durserday,startatday,day_prop,dayflight,vessel,attend,dur_attend,dur_attend_day,prop_attend,dayprop_attend,avgdist_attend,avgdist_dayattend,avg_nbbatrangedet))
  }
}


#write.table(attrser,paste("BBA14minBoat10min_","DetectionSeries_",attrac.threshold,"km_",attend.threshold,"km_","TTR",timetoreturn,"locs.csv",sep=""),sep=";",row.names=F)





### Complete attrser with Boat activity parameters
attrser=read.table(paste("BBA14minBoat10min_","DetectionSeries_",attrac.threshold,"km_",attend.threshold,"km_","TTR",timetoreturn,"locs.csv",sep=""),sep=";",h=T)
names(attrser)=c("BirdID","File","Serie","startloc","startlocbat","startdate","starttime","endloc","endlocbat","enddate","endtime","durser","durserday","daystart","prop_day","dayflight","vessel","attend","dur_attend","dur_dayattend","prop_attend","dayprop_attend","avgdist_attend","avgdist_dayattend","avg_nbbatrangedet")

time1=c()
for (j in 1:length(attrser$startdate)){
  Date=unlist(strsplit(as.character(attrser$startdate[j]),"/"))
  Time=as.character(attrser$starttime[j])
  time1=append(time1, paste(paste(as.character(Date[3]),as.character(Date[2]),as.character(Date[1]), sep='-'),Time, sep=' '))
}
time1=as.POSIXct(time1,tz='GMT')


attrser$BirdID=unlist(lapply(strsplit(as.character(attrser$File),","),function(X){X[1]}))

vesselsdata="D:/Pro/These/Donnees/Bateaux/VesselsData/InterpolCombinedReady/Ker2011/"
boatfiles=list.files(vesselsdata)


lagvesact=c()
actves=c()
propact=c()
for (ser in 1:length(attrser$File)){
  boat=boatfiles[attrser$vessel[ser]]
  bo=read.table(paste(vesselsdata,boat,sep=""),h=T,sep=";")
  
  time2=c()
  for (j in 1:length(bo$Date)){
    Date=unlist(strsplit(as.character(bo$Date[j]),"/"))
    Time=as.character(bo$Time[j])
    time2=append(time2, paste(paste(as.character(Date[3]),as.character(Date[2]),as.character(Date[1]), sep='-'),Time, sep=' '))
  }
  time2=as.POSIXct(time2,tz='GMT')
  
  startdate=time1[ser]
  loclagvesact=which.min(abs(difftime(startdate,time2[bo$Type_loc!="track" & bo$Type_loc!="int"],units="secs")))
  lagvesact=c(lagvesact,as.double(difftime(startdate,time2[bo$Type_loc!="track" & bo$Type_loc!="int"][loclagvesact],units="secs")))
  actves=c(actves,as.character(bo$Type_loc[bo$Type_loc!="track" & bo$Type_loc!="int"][loclagvesact]))
  
  bo$Type_loc=as.character(bo$Type_loc)
  propact=c(propact,sum(bo$Type_loc[attrser$startlocbat[ser]:attrser$endlocbat[ser]]!="track" & bo$Type_loc[attrser$startlocbat[ser]:attrser$endlocbat[ser]]!="int")/(length(attrser$startlocbat[ser]:attrser$endlocbat[ser])))
}
attrser$lagvesact=-lagvesact
attrser$closestvesact=actves
attrser$propact=propact

#write.table(attrser,paste("BBA14minBoat10min_","DetectionSeries_",attrac.threshold,"km_",attend.threshold,"km_","TTR",timetoreturn,"locs.csv",sep=""),sep=";",row.names=F)





### Add trip-level data
setwd("D:/Pro/These/Donnees/WAvsBBA/")
metabba=read.table("BBA/MetaBBAToVessels.csv",sep=";",h=T)
metabba$TripID=as.character(metabba$TripID)
for(t in unique(as.character(attrser$File))){
  attrser$Sex[attrser$File==t]=as.character(metabba$sex[metabba$TripID==t])
  attrser$ReproStage[attrser$File==t]=as.character(metabba$ReproStat[metabba$TripID==t])
  attrser$Bague[attrser$File==t]=as.character(metabba$Bague[metabba$TripID==t])
  attrser$TripDuration[attrser$File==t]=metabba$duration[metabba$TripID==t]/24
  attrser$MaxRange[attrser$File==t]=metabba$maxrange[metabba$TripID==t]
  attrser$avg_nbbat[attrser$File==t]=metabba$AvgNbBat350km[metabba$TripID==t]
}

#write.table(attrser,paste("BBA14minBoat10min_","DetectionSeries_",attrac.threshold,"km_",attend.threshold,"km_","TTR",timetoreturn,"locs.csv",sep=""),sep=";",row.names=F)










